function MitigationPercent:SetupAddonMenu()
	
	self.LAM = LibStub("LibAddonMenu-2.0")
	
	local panelData = {
        type = "panel",
        name = self.name,
        displayName = ZO_ColorDef:New("E6B85C"):Colorize(self.name),
        author = "coolmodi",
        version = self.version,
        registerForRefresh = true,
        registerForDefaults = true,
		resetFunc = function() 
			self.savedVariables.displayPanel		= false 
			self.savedVariables.showInCharScreen	= true
			self.savedVariables.panelColorR			= 255
			self.savedVariables.panelColorG			= 255
			self.savedVariables.panelColorB			= 255
			self.savedVariables.textSize			= 18
			self.savedVariables.boldText			= false
			self.savedVariables.hideMode			= false
			self.savedVariables.useBlock			= false
			self.savedVariables.usePassives			= false
			self.savedVariables.showPen				= true
			self.savedVariables.showOther			= false
			self.savedVariables.offset 				= {x = 920, y = 450}
			ReloadUI()
		end
    }
	
	self.LAM:RegisterAddonPanel(self.name .. 'Panel', panelData)
	
	local optionsTable = {		
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_MITIGATIONPERCENT_MENU_CAT_STATSCREEN)),
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWINSTATS),
			tooltip = GetString(SI_MITIGATIONPERCENT_MENU_TOOLTIP_SHOWINSTATS),
			getFunc = function() return self.savedVariables.showInCharScreen end,
			setFunc = function() self.savedVariables.showInCharScreen = not self.savedVariables.showInCharScreen end,
			warning = GetString(SI_MITIGATIONPERCENT_MENU_WARNING_RELOADUI),
		},		
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWPEN),
			tooltip = GetString(SI_MITIGATIONPERCENT_MENU_TOOLTIP_SHOWPEN),
			getFunc = function() return self.savedVariables.showPen end,
			setFunc = function() self.savedVariables.showPen = not self.savedVariables.showPen end,
			warning = GetString(SI_MITIGATIONPERCENT_MENU_WARNING_RELOADUI),
			disabled = function() if self.savedVariables.showInCharScreen == false then return true end end,
		},		
		{
            type = "button",
            name = GetString(SI_MITIGATIONPERCENT_MENU_BUTTON_RELOAD),
            func = function() ReloadUI() end,
        },
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_MITIGATIONPERCENT_MENU_CAT_PANEL)),
		},		
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWPANEL),
			tooltip = GetString(SI_MITIGATIONPERCENT_MENU_TOOLTIP_SHOWPANEL),
			getFunc = function() return self.savedVariables.displayPanel end,
			setFunc = function() self.savedVariables.displayPanel = not self.savedVariables.displayPanel
				if self.savedVariables.displayPanel == false then 
					MitigationPercentDisplayLabel:SetHidden(true)
					MitigationPercentDisplay:SetMouseEnabled(false)
					MitigationPercentDisplay:SetMovable(false)
					EVENT_MANAGER:UnregisterForEvent(self.name, EVENT_STATS_UPDATED)
				else 
					MitigationPercentDisplayLabel:SetHidden(false)
					MitigationPercentDisplay:SetMouseEnabled(true)
					MitigationPercentDisplay:SetMovable(true)
					EVENT_MANAGER:RegisterForEvent(self.name, EVENT_STATS_UPDATED, self.OnStatsUpdated)
					EVENT_MANAGER:AddFilterForEvent(self.name, EVENT_STATS_UPDATED, REGISTER_FILTER_UNIT_TAG, "player")
					if self.savedVariables.hideMode == true then					
						MitigationPercentDisplay:SetMovable(false)
						MitigationPercentDisplay:SetMouseEnabled(false)
					end
				end 
				self:UpdatePanel()
				end,
		},
		{
			type = "colorpicker",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_FONTCOLOR),
			getFunc = function() return self.savedVariables.panelColorR, self.savedVariables.panelColorG, self.savedVariables.panelColorB end,
			setFunc = function(r,g,b,a)
				self.savedVariables.panelColorR = r
				self.savedVariables.panelColorG = g
				self.savedVariables.panelColorB = b
				
				MitigationPercentDisplayLabel:SetColor(r,g,b)
			end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "slider",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SIZE),
			min = 10,
			max = 50,
			step = 1,
			getFunc = function() return self.savedVariables.textSize end,
			setFunc = function(number) self.savedVariables.textSize = number
				local textSizeString = "MEDIUM"
				if self.savedVariables.boldText == true then
					textSizeString = "BOLD"
				end
				MitigationPercentDisplayLabel:SetFont(tostring("$(" .. textSizeString .. "_FONT)|" .. number .. "|soft-shadow-thin")) end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_BOLD),
			getFunc = function() return self.savedVariables.boldText end,
			setFunc = function() self.savedVariables.boldText = not self.savedVariables.boldText 
				local textSizeString = "MEDIUM"
				if self.savedVariables.boldText == true then
					textSizeString = "BOLD"
				end
				MitigationPercentDisplayLabel:SetFont(tostring("$(" .. textSizeString .. "_FONT)|" .. self.savedVariables.textSize .. "|soft-shadow-thin"))
			end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},			
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_AUTOHIDELOCK),
			tooltip = GetString(SI_MITIGATIONPERCENT_MENU_TOOLTIP_AUTOHIDELOCK),
			getFunc = function() return self.savedVariables.hideMode end,
			setFunc = function() self.savedVariables.hideMode = not self.savedVariables.hideMode 
				if self.savedVariables.hideMode == true then
					MitigationPercentDisplay:SetMovable(false)
					MitigationPercentDisplay:SetMouseEnabled(false)
					self.hudScene:AddFragment(self.panelFragment)
					self.hudUiScene:AddFragment(self.panelFragment)
				else
					MitigationPercentDisplay:SetMovable(true)
					MitigationPercentDisplay:SetMouseEnabled(true)
					self.hudScene:RemoveFragment(self.panelFragment)
					self.hudUiScene:RemoveFragment(self.panelFragment)
					self.panelFragment:Show()
				end
			end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWRES),
			getFunc = function() return self.savedVariables.labelShowRes end,
			setFunc = function() self.savedVariables.labelShowRes = not self.savedVariables.labelShowRes self:UpdatePanel() end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWPWR),
			getFunc = function() return self.savedVariables.labelShowPwr end,
			setFunc = function() self.savedVariables.labelShowPwr = not self.savedVariables.labelShowPwr self:UpdatePanel() end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWCRIT),
			getFunc = function() return self.savedVariables.labelShowCrit end,
			setFunc = function() self.savedVariables.labelShowCrit = not self.savedVariables.labelShowCrit self:UpdatePanel() end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},
		{
			type = "checkbox",
			name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_SHOWPENPAN),
			getFunc = function() return self.savedVariables.labelShowPen end,
			setFunc = function() self.savedVariables.labelShowPen = not self.savedVariables.labelShowPen self:UpdatePanel() end,
			disabled = function() if self.savedVariables.displayPanel == false then return true end end,
		},	
		{
			type = "submenu",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_MITIGATIONPERCENT_MENU_CAT_HARDCAP)),
			tooltip = GetString(SI_MITIGATIONPERCENT_MENU_TOOLTIP_HARDCAP),
			controls = {
				{
					type = "editbox",
					name = GetString(SI_MITIGATIONPERCENT_MENU_NAME_HARDCAP),
					getFunc = function() return 100 + 500*GetUnitEffectiveLevel("player") end,
					setFunc = function() end,
				},
				{
					type = "description",
					text = GetString(SI_MITIGATIONPERCENT_MENU_TEXT_HARDCAPDESC),
				}
			}
		},
		{
			type = "submenu",
			name = ZO_ColorDef:New("909090"):Colorize("WIP stuff"),
			tooltip = "Use/test if you like, may not work correctly and is also not complete!",
			controls = {
				{
					type = "description",
					text = "These options will make the values in the panel (not character screen) take blocking and passives into account. After changing skills/passives you have to reload your UI or type /mpupdate, this will also output some info of what it does.",
				},
				{
					type = "checkbox",
					name = "Blocking + passives",
					tooltip = "Take blocking and block passives into account. Will use 1H&S passives and skills regardless of a shield beeing used and the skill beeing in the bar or not!",
					getFunc = function() return self.savedVariables.useBlock end,
					setFunc = function() self.savedVariables.useBlock = not self.savedVariables.useBlock 
						if self.savedVariables.useBlock then
							EVENT_MANAGER:RegisterForEvent(self.name, EVENT_EFFECT_CHANGED, self.onBuffChange)
							EVENT_MANAGER:AddFilterForEvent(self.name, EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, "player")
						else
							EVENT_MANAGER:UnregisterForEvent(self.name, EVENT_EFFECT_CHANGED)
						end		  
					end,
				},
				{
					type = "checkbox",
					name = "Other passives",
					tooltip = "Currently only for Nord passive, is there even anything else? I have no nord to test, so there is a huge chance this is calculated totally wrong!",
					getFunc = function() return self.savedVariables.usePassives end,
					setFunc = function() self.savedVariables.usePassives = not self.savedVariables.usePassives end,
				},
			}
		}
	}
	
	self.LAM:RegisterOptionControls(self.name .. 'Panel', optionsTable)
end